# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para filmixt
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

CHANNELNAME = "filmixt"
DEBUG = True

def isGeneric():
    return True

def mainlist(item):
    logger.info("[filmixt.py] mainlist")
    itemlist=[]

    # Descarga la página
    item.url = "http://filmixt.com/"
    
    # Hace el login para obtener la cookie
    #data = scrapertools.cache_page(item.url,post="username=...
    
    # Descarga la home
    data = scrapertools.cache_page(item.url)
    patron = '<a href="(descarga[^"]+)" class="([^"]+)"></a>'
    matches = re.compile(patron,re.DOTALL).findall(data)
    if DEBUG: scrapertools.printMatches(matches)

    itemlist = []
    for match in matches:
        scrapedtitle = match[1]
        scrapedplot = ""
        scrapedurl = urlparse.urljoin(item.url,match[0])
        scrapedthumbnail = ""
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        itemlist.append( Item(channel=CHANNELNAME, action="peliculas", title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=True) )

    return itemlist

def peliculas(item):
    logger.info("[filmixt.py] peliculas")
    itemlist=[]

    # Descarga la página
    '''
    <div class="fichaMiniPortada">
    <a href="http://filmixt.com/descargar-criadas-y-sentildeoras-12618.fx" class="imagenFicha" title="The Help" style="background-image:url(fx/media/imgs/12/12827E.jpg);"></a>    
    <a href="http://filmixt.com/descargar-criadas-y-sentildeoras-12618.fx" class="titleFicha" title="The Help">Criadas Y Se&ntilde;oras </a>
    <a href="descarga-3-0-0-0-fx-1-1.fx" class="calidadFicha" title="Lista de peliculas en DVD Screener">DVD Screener <span style="font-size:10px;font-weight:normal;">2011</span></a>
    <div class="masdatos">
    <img alt="" src="themes/filmixt/Miniimgs/banderita1.png"><img alt="" src="themes/filmixt/Miniimgs/Megaupload.com.png"><img alt="" src="themes/filmixt/Miniimgs/Fileserve.com.png"><img alt="" src="themes/filmixt/Miniimgs/Downupload.com.png">
    </div>
    '''
    data = scrapertools.cachePage(item.url)
    patron = '<div class="fichaMiniPortada">(.*?)</div>'
    matches = re.compile(patron,re.DOTALL).findall(data)

    for match in matches:
        logger.info("pelicula="+match)
        patron2  = '<a href="([^"]+)" class="imagenFicha" title="[^"]+" style="background\-image\:url\(([^\)]+)\)\;"></a[^<]+'
        patron2 += '<a href="[^"]+" class="titleFicha" title="[^"]+">([^<]+)</a>[^<]+'
        patron2 += '<a href="[^"]+" class="calidadFicha" title="[^"]+">([^<]+)<'
        matches2 = re.compile(patron2,re.DOTALL).findall(match)
        scrapertools.printMatches(matches2)
        
        for match2 in matches2:
            scrapedtitle = match2[2]+" ("+match2[3]+")"
            scrapedplot = ""
            scrapedurl = urlparse.urljoin(item.url,match2[0])
            scrapedthumbnail = urlparse.urljoin(item.url,match2[1])
            if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
            
            itemlist.append( Item(channel=CHANNELNAME, action="findvideos", title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=True) )

    # Paginación
    patron = '<a href="([^"]+)">Siguiente \&raquo\;</a>'
    matches = re.compile(patron,re.DOTALL).findall(data)
    if DEBUG: scrapertools.printMatches(matches)

    for match in matches:
        scrapedtitle = "!Página siguiente"
        scrapedplot = ""
        scrapedurl = urlparse.urljoin(item.url,match)
        scrapedthumbnail = ""
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        itemlist.append( Item(channel=CHANNELNAME, action="peliculas", title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=True) )

    return itemlist

def findvideos(item):
    logger.info("[filmixt.py] find_videos")
    itemlist=[]

    data = scrapertools.cache_page(item.url)
    patron ='<div class="links">[^<]+'
    patron+='<a href="([^"]+)"'
    matches = re.compile(patron,re.DOTALL).findall(data)

    for match in matches:
        logger.info("match="+match)
        data = scrapertools.cache_page(match)
        logger.info("data="+data)
        itemlist.extend( servertools.find_video_items(data=data) )
        
    return itemlist